/* =====================================
=== LIMEREG - Lightweight Image Registration ===
========================================

Forked from the project FIMREG, which was written for a distributed calculation on the PCIe card DSPC-8681 of Advantech. LIMEREG does not use DSPs and can
be run on an ordinary PC without special hardware. FIMREG was originally developed by by Roelof Berg, Berg Solutions (rberg@berg-solutions.de) with support
from Lars Koenig, Fraunhofer MEVIS (lars.koenig@mevis.fraunhofer.de) and Jan Ruehaak, Fraunhofer MEVIS (jan.ruehaak@mevis.fraunhofer.de).

THIS IS A LIMITED RESEARCH PROTOTYPE. Documentation: www.berg-solutions.de/limereg.html

------------------------------------------------------------------------------

Copyright (c) 2014, Roelof Berg
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

* Neither the name of the owner nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

----------------------------------------------------------------------------*/

/*
 * gen_example_data.cpp
 *
 * CODE GENERATED BY MATLAB CODER (THE HUMAN READABILITY IS THEREFORE LIMITED)
 *
 */

#include "stdafx.h"

/* Include files */
#include "rt_nonfinite.h"
 
#include "diffimg.h"
 
#include "gaussnewton.h"
#include "gen_example_data.h"
#include "generatePyramidPC.h"
 
#include "jacobian.h"
 
 
#include "ssd.h"
 
 
 
#include "transform.h"
 
 
#include "limereg_emxutil.h"
#include "limereg_rtwutil.h"

/* Custom Source Code */
#include "pseudo_stdafx.h"             //precompiled header not possible because of include position of matlab
namespace Limereg {

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */

/* Function Definitions */
void gen_example_data(const real64_T wi[3], uint32_T d, emxArray_uint8_T *Rvec,
                      emxArray_uint8_T *Tvec)
{
  emxArray_uint8_T *R;
  int32_T i35;
  int32_T nx;
  uint32_T mn;
  real64_T r_mitte;
  uint32_T r_links;
  uint32_T r_rechts;
  int32_T i36;
  int32_T k21;
  int32_T k11;
  emxArray_int32_T *r1;
  emxArray_int32_T *r2;
  int32_T k12;
  int32_T unnamed_idx_1;
  uint32_T Ax;
  emxArray_int32_T *r3;
  emxArray_int32_T *r4;
  emxArray_int32_T *r5;
  emxArray_int32_T *r6;
  emxArray_uint8_T *x;
  int32_T sz[2];
  emxArray_uint8_T *y;
  emxArray_uint8_T *b_Rvec;
  real64_T b_y;
  real64_T dmax;
  real64_T c_y;
  real64_T X_mni;
  real64_T FA_i;
  int32_T k22;
  b_emxInit_uint8_T(&R, 2);

  /* Referenzbild */
  i35 = R->size[0] * R->size[1];
  R->size[0] = (int32_T)d;
  R->size[1] = (int32_T)d;
  emxEnsureCapacity((emxArray__common *)R, i35, (int32_T)sizeof(uint8_T));
  nx = (int32_T)d * (int32_T)d - 1;
  for (i35 = 0; i35 <= nx; i35++) {
    R->data[i35] = 0;
  }

  mn = (uint32_T)rt_roundf_snf((real64_T)d / 2.0F);
  r_mitte = (real64_T)rt_roundf_snf((real64_T)d / 2.0F);
  r_links = (uint32_T)rt_roundf_snf((real64_T)floor((real64_T)mn - r_mitte /
    2.0F) + 1.0F);
  r_rechts = (uint32_T)(real64_T)ceil((real64_T)mn + r_mitte / 2.0F);
  if (r_links > r_rechts) {
    i35 = 1;
    i36 = 0;
  } else {
    i35 = (int32_T)r_links;
    i36 = (int32_T)r_rechts;
  }

  if (r_links > r_rechts) {
    k21 = 1;
    k11 = 0;
  } else {
    k21 = (int32_T)r_links;
    k11 = (int32_T)r_rechts;
  }

  emxInit_int32_T(&r1, 1);
  nx = r1->size[0];
  r1->size[0] = (i36 - i35) + 1;
  emxEnsureCapacity((emxArray__common *)r1, nx, (int32_T)sizeof(int32_T));
  nx = i36 - i35;
  for (i36 = 0; i36 <= nx; i36++) {
    r1->data[i36] = i35 + i36;
  }

  emxInit_int32_T(&r2, 1);
  i36 = r2->size[0];
  r2->size[0] = (k11 - k21) + 1;
  emxEnsureCapacity((emxArray__common *)r2, i36, (int32_T)sizeof(int32_T));
  nx = k11 - k21;
  for (i36 = 0; i36 <= nx; i36++) {
    r2->data[i36] = k21 + i36;
  }

  k12 = r1->size[0];
  unnamed_idx_1 = r2->size[0];
  emxFree_int32_T(&r2);
  emxFree_int32_T(&r1);
  nx = unnamed_idx_1 - 1;
  for (i36 = 0; i36 <= nx; i36++) {
    unnamed_idx_1 = k12 - 1;
    for (k11 = 0; k11 <= unnamed_idx_1; k11++) {
      R->data[((i35 + k11) + R->size[0] * ((k21 + i36) - 1)) - 1] = MAX_uint8_T;
    }
  }

  r_links = (uint32_T)rt_roundf_snf((real64_T)floor((real64_T)mn - r_mitte /
    4.0F) + 1.0F);
  r_rechts = (uint32_T)(real64_T)ceil((real64_T)mn + r_mitte / 4.0F);
  mn = (r_links - r_rechts) + r_links;
  if (mn > r_links) {
    i35 = 1;
    i36 = 0;
  } else {
    i35 = (int32_T)mn;
    i36 = (int32_T)r_links;
  }

  mn = r_links - (uint32_T)(real64_T)floor((real64_T)d * 0.05F);
  Ax = r_rechts - (uint32_T)(real64_T)floor((real64_T)d * 0.05F);
  if (mn > Ax) {
    k21 = 1;
    k11 = 0;
  } else {
    k21 = (int32_T)mn;
    k11 = (int32_T)Ax;
  }

  emxInit_int32_T(&r3, 1);
  nx = r3->size[0];
  r3->size[0] = (i36 - i35) + 1;
  emxEnsureCapacity((emxArray__common *)r3, nx, (int32_T)sizeof(int32_T));
  nx = i36 - i35;
  for (i36 = 0; i36 <= nx; i36++) {
    r3->data[i36] = i35 + i36;
  }

  emxInit_int32_T(&r4, 1);
  i36 = r4->size[0];
  r4->size[0] = (k11 - k21) + 1;
  emxEnsureCapacity((emxArray__common *)r4, i36, (int32_T)sizeof(int32_T));
  nx = k11 - k21;
  for (i36 = 0; i36 <= nx; i36++) {
    r4->data[i36] = k21 + i36;
  }

  k12 = r3->size[0];
  unnamed_idx_1 = r4->size[0];
  emxFree_int32_T(&r4);
  emxFree_int32_T(&r3);
  nx = unnamed_idx_1 - 1;
  for (i36 = 0; i36 <= nx; i36++) {
    unnamed_idx_1 = k12 - 1;
    for (k11 = 0; k11 <= unnamed_idx_1; k11++) {
      R->data[((i35 + k11) + R->size[0] * ((k21 + i36) - 1)) - 1] = 20;
    }
  }

  mn = r_links + (uint32_T)(real64_T)floor((real64_T)d * 0.1F);
  Ax = r_rechts + (uint32_T)(real64_T)floor((real64_T)d * 0.1F);
  if (mn > Ax) {
    i35 = 1;
    i36 = 0;
  } else {
    i35 = (int32_T)mn;
    i36 = (int32_T)Ax;
  }

  emxInit_int32_T(&r5, 1);
  mn = r_rechts - r_links;
  k21 = r5->size[0];
  r5->size[0] = (int32_T)mn + 1;
  emxEnsureCapacity((emxArray__common *)r5, k21, (int32_T)sizeof(int32_T));
  for (k21 = 0; k21 <= (int32_T)mn; k21++) {
    r5->data[k21] = (int32_T)((uint32_T)k21 + r_rechts);
  }

  emxInit_int32_T(&r6, 1);
  k21 = r6->size[0];
  r6->size[0] = (i36 - i35) + 1;
  emxEnsureCapacity((emxArray__common *)r6, k21, (int32_T)sizeof(int32_T));
  nx = i36 - i35;
  for (i36 = 0; i36 <= nx; i36++) {
    r6->data[i36] = i35 + i36;
  }

  k12 = r5->size[0];
  unnamed_idx_1 = r6->size[0];
  emxFree_int32_T(&r6);
  nx = unnamed_idx_1 - 1;
  for (i36 = 0; i36 <= nx; i36++) {
    unnamed_idx_1 = k12 - 1;
    for (k21 = 0; k21 <= unnamed_idx_1; k21++) {
      R->data[(r5->data[k21] + R->size[0] * ((i35 + i36) - 1)) - 1] = 130;
    }
  }

  emxFree_int32_T(&r5);
  b_emxInit_uint8_T(&x, 2);
  i35 = x->size[0] * x->size[1];
  x->size[0] = R->size[1];
  x->size[1] = R->size[0];
  emxEnsureCapacity((emxArray__common *)x, i35, (int32_T)sizeof(uint8_T));
  nx = R->size[0] - 1;
  for (i35 = 0; i35 <= nx; i35++) {
    unnamed_idx_1 = R->size[1] - 1;
    for (i36 = 0; i36 <= unnamed_idx_1; i36++) {
      x->data[i36 + x->size[0] * i35] = R->data[i35 + R->size[0] * i36];
    }
  }

  emxFree_uint8_T(&R);
  nx = x->size[0] * x->size[1];
  for (i35 = 0; i35 < 2; i35++) {
    sz[i35] = 0;
  }

  b_emxInit_uint8_T(&y, 2);
  sz[0] = 1;
  sz[1] = 1;
  sz[1] = nx;
  i35 = y->size[0] * y->size[1];
  y->size[0] = 1;
  y->size[1] = sz[1];
  emxEnsureCapacity((emxArray__common *)y, i35, (int32_T)sizeof(uint8_T));
  for (unnamed_idx_1 = 0; unnamed_idx_1 + 1 <= nx; unnamed_idx_1++) {
    y->data[unnamed_idx_1] = x->data[unnamed_idx_1];
  }

  emxFree_uint8_T(&x);
  b_emxInit_uint8_T(&b_Rvec, 2);
  i35 = b_Rvec->size[0] * b_Rvec->size[1];
  b_Rvec->size[0] = y->size[1];
  b_Rvec->size[1] = 1;
  emxEnsureCapacity((emxArray__common *)b_Rvec, i35, (int32_T)sizeof(uint8_T));
  nx = y->size[1] - 1;
  for (i35 = 0; i35 <= nx; i35++) {
    b_Rvec->data[i35] = y->data[y->size[0] * i35];
  }

  emxFree_uint8_T(&y);

  /* Vektorisierte Darstellung */
  mn = d * d;
  b_y = (real64_T)d / 2.0F;
  dmax = (real64_T)d / 2.0F - 0.5F;
  c_y = (real64_T)d / 2.0F;

  /* Shifting, um negative Koordinaten in Matrixbereich zu bringen */
  /* ======================================================================== */
  /* = Registerweise statt matrizenbasiert */
  /* ======================================================================== */
  i35 = Rvec->size[0];
  Rvec->size[0] = (int32_T)mn;
  emxEnsureCapacity((emxArray__common *)Rvec, i35, (int32_T)sizeof(uint8_T));
  nx = (int32_T)mn - 1;
  for (i35 = 0; i35 <= nx; i35++) {
    Rvec->data[i35] = 0;
  }

  mn = 1U;

  /* Folgende beiden For-Loops laufen 1..mn mal durch das pixelmittige Koordinatengitter */
  /* Dabei zeigt i auf die Position von 1..mn */
  i35 = (int32_T)((b_y - 0.5F) + (1.0F - (-dmax)));
  for (nx = 0; nx <= i35 - 1; nx++) {
    X_mni = -dmax + (real64_T)nx;
    i36 = (int32_T)((b_y - 0.5F) + (1.0F - (-dmax)));
    for (unnamed_idx_1 = 0; unnamed_idx_1 <= i36 - 1; unnamed_idx_1++) {
      r_mitte = -dmax + (real64_T)unnamed_idx_1;

      /* Die Zeilenvektoren FP(1)*X_i und FP(4)*X_i k�nnten vorberechnet */
      /* werden (mit FP(3) und FP(6), sowie +s schon mit drin ... */
      FA_i = (0.707106769F * r_mitte + -0.707106769F * X_mni) + (c_y + 0.5F);
      r_mitte = (0.707106769F * r_mitte + 0.707106769F * X_mni) + (c_y + 0.5F);

      /* +s weil Drehpunkt in Bildmitte */
      Ax = (uint32_T)rt_roundf_snf((real64_T)floor(FA_i));
      r_links = (uint32_T)rt_roundf_snf((real64_T)floor(r_mitte));

      /* Fetch picture values (how can we cache-optimize this ? Intelligent routing ?) */
      k11 = 0;
      k12 = 0;
      k21 = 0;
      k22 = 0;
      if ((Ax >= 1U) && (Ax < d) && (r_links >= 1U) && (r_links < d)) {
        k11 = b_Rvec->data[(int32_T)((r_links - 1U) * d + Ax) - 1];
        k12 = b_Rvec->data[(int32_T)((r_links - 1U) * d + Ax)];
        k21 = b_Rvec->data[(int32_T)(r_links * d + Ax) - 1];
        k22 = b_Rvec->data[(int32_T)(r_links * d + Ax)];
      }

      /* Interpolation */
      FA_i -= (real64_T)floor(FA_i);
      r_mitte -= (real64_T)floor(r_mitte);
      Rvec->data[(int32_T)mn - 1] = (uint8_T)rt_roundf_snf((((real64_T)k11 *
        (1.0F - FA_i) * (1.0F - r_mitte) + (real64_T)k12 * FA_i * (1.0F -
        r_mitte)) + (real64_T)k21 * (1.0F - FA_i) * r_mitte) + (real64_T)k22 *
        FA_i * r_mitte);
      mn++;
    }
  }

  emxFree_uint8_T(&b_Rvec);

  /* Templatebild */
  transform(wi, Rvec, d, Tvec);
}

}

/* End of code generation (gen_example_data.cpp) */
